SortGroup_SavedVariables_DB = {};
local L = LibStub("AceLocale-3.0"):GetLocale("SortGroup")
local UpdateTable = {}

local frame_Main = CreateFrame("Frame", "SortGroupPanel", InterfaceOptionsFramePanelContainer);
local frame_Options = CreateFrame("Frame", "SortGroupPanelOptions", frame_Main);
-- Main Frame

local defaultValues_DB = {
	Top = true,
	TopDescending = true,
	TopAscending = false,
	Bottom = false,
	BottomDescending = false,
	BottomAscending = false,
	AlwaysActive = false,
	AutoActivate = true,
	Profile = nil,
	RaidProfilesUpdateInCombat = false,
	ChatMessagesOn = true,
	FreshDB = true
}

local internValues_DB = {
	EscIntepretAsOK = false, 
	--Personal recommendation to activate this. Pressing Cancel/Esc will get interpretet as OK - less taint and issues overall. However, someone might don't want this
	RaidProfilesUpdateInCombatVisibility = false, 
	--Since the friendly nameplate changes this can cause issues in a raid environment. Other then that, it doesn't seem to cause any issue. 
	ChangesInCombat = false;
	--You can change options in combat. Not really recommended
	CatchProfileSwitchEvent = false,
	--Experimental. If activated, every manual switch will automatically activate the sort function - to apply it to the new profile. This will cause issues !
	DebugModeActive = false,
	DebugModeLevel = 2
	-- debugging, false = deactivated
	-- 1 Options
	-- 2 Events+Method Names
	-- 4 Methods content
	-- combinable, so 7 = everything
}
-- Options, which are only changeable here atm. These can cause taint and errors, but can also be useful. Activate on own "risk"  

local intern_showChatMessages = false;
-- true when "PLAYER_ENTERING_WORLD" fired or cb Event gets triggered
-- so intern cache, for messages not getting displayed all the time

local intern_inCombat = false;
-- true when "PLAYER_REGEN_DISABLED" fired


local fontFrame_Main = frame_Main:CreateFontString("SortGroup_Title", "OVERLAY", "GameFontHighlight");
local fontFrame_Options = frame_Options:CreateFontString("Option_Title", "OVERLAY", "GameFontHighlight");

local textVersion = CreateFrame("SimpleHTML", "textVersion_Text", frame_Main);
local textAuthor = CreateFrame("SimpleHTML", "textAuthor_Text", frame_Main); 
local versionNumber = "4.0 Alpha";
local version = "|cFF00FF00Version|r  " .. versionNumber
local authorName = "Collabo93"
local author = "|cFF00FF00Author|r   " .. authorName
-- Text

local cBTop_Main = CreateFrame("CheckButton", "CheckButtonTop_Text", frame_Main, "UICheckButtonTemplate");
local cBBottom_Main = CreateFrame("CheckButton", "CheckButtonBottom_Text", frame_Main, "UICheckButtonTemplate");
local cbTopDescending_Main = CreateFrame("CheckButton", "CheckButtonTopDownwards_Text", cBTop_Main, "UICheckButtonTemplate");
local cbTopAscending_Main = CreateFrame("CheckButton", "CheckButtonTopUpwards_Text", cBTop_Main, "UICheckButtonTemplate");
local cbBottomDescending_Main = CreateFrame("CheckButton", "CheckButtonBottomDownwards_Text", cBBottom_Main, "UICheckButtonTemplate");
local cbBottomAscending_Main = CreateFrame("CheckButton", "CheckButtonBottomUpwards_Text", cBBottom_Main, "UICheckButtonTemplate");
local cbAlwaysActive_Main = CreateFrame("CheckButton", "CheckButtonRegardlessRaidProfile_Text", frame_Main, "UICheckButtonTemplate");
local cbAutoActivate_Main = CreateFrame("CheckButton", "CheckButtonAutoActivate_Text", cbAlwaysActive_Main, "UICheckButtonTemplate");

local cbChatMessagesOn_Options = CreateFrame("CheckButton", "CheckButtonChatMessagesOn_Text", frame_Options, "UICheckButtonTemplate");
local cbRaidProfilesUpdateInCombat_Options = CreateFrame("CheckButton", "CheckButtonRaidProfilesUpdateInCombat_Text", frame_Options, "UICheckButtonTemplate");
-- Combo-box Options

local btnReload_Options = CreateFrame("Button", "page3btnReload_Text", frame_Options, "UIPanelButtonTemplate");
-- Button

local ddmProfiles = CreateFrame("Button", "DropDownMenuProfiles", cbAutoActivate_Main, "UIDropDownMenuTemplate");
local ddmItems = {};
-- DropDownMenu

local defaultColor = "#FFFFFF";
---End Variables

local function ColorText(text, operation)
	if ( operation == "option" ) then
		local cacheText = text:gsub("SortGroup:" , function(cap)
			cap = cap:sub(1, -1);
			local color = "|cff00FF7F" or defaultColor;
			return color..cap.."|r";
		end)
		return cacheText;
	elseif ( operation == "disable" ) then
		local color = "|cff888888" or defaultColor;
		return color..text;
	elseif ( operation == "green" ) then
		local color = "|cff00ff00" or defaultColor;
		return color..text;
	elseif ( operation == "red" ) then
		local color = "|cffff0000" or defaultColor;
		return color..text;
	elseif ( operation == "white" ) then
		local color = "|cffffffff" or defaultColor;
		return color..text;
	end
end

local function Debug(methodName, methodContent, methodLevel)
	if ( internValues_DB.DebugModeActive == true ) then
		local SortGroup_Variable_debugMethodNameCache = nil;
		local SortGroup_Variable_debugMethodContentCache = nil;
		local SortGroup_Variable_debugMethodNamePrint = true;
		if ( internValues_DB.DebugModeLevel % 2 == 1 and methodLevel >= 1 ) then
			internValues_DB.DebugModeLevel = internValues_DB.DebugModeLevel - 1;
			if ( methodLevel == 1 ) then
				SortGroup_Variable_debugMethodNamePrint = true;
				print(ColorText("SortGroup: Debuging - Options", "option"));
				print("'defaultValues_DB.Top' " .. tostring(defaultValues_DB.Top));
				print("'defaultValues_DB.TopDescending' " .. tostring(defaultValues_DB.TopDescending));
				print("'defaultValues_DB.TopAscending' " .. tostring(defaultValues_DB.TopAscending));
				print("'defaultValues_DB.Bottom' " .. tostring(defaultValues_DB.Bottom));
				print("'defaultValues_DB.BottomDescending' " .. tostring(defaultValues_DB.BottomDescending));
				print("'defaultValues_DB.Profile' " .. tostring(defaultValues_DB.Profile));
				print("'AutoActivate' " .. tostring(defaultValues_DB.AutoActivate));
				print("'defaultValues_DB.AlwaysActive' " .. tostring(defaultValues_DB.AlwaysActive));
				print("'defaultValues_DB.ChatMessagesOn' " .. tostring(defaultValues_DB.ChatMessagesOn));
				print("'defaultValues_DB.RaidProfilesUpdateInCombat' " .. tostring(defaultValues_DB.RaidProfilesUpdateInCombat));
			end
		end
		if ( ( internValues_DB.DebugModeLevel == 2 or internValues_DB.DebugModeLevel == 6 ) and methodLevel >= 2 ) then
			if ( SortGroup_Variable_debugMethodNameCache ~= methodName ) then
				if ( SortGroup_Variable_debugMethodNamePrint == true ) then
					print(ColorText("SortGroup: Debuging - Method Names", "option"));
					SortGroup_Variable_debugMethodNamePrint = false;
				end
				print("'" ..  methodName .. "()'");
				SortGroup_Variable_debugMethodNameCache = methodName;
			end
		end
		if ( internValues_DB.DebugModeLevel >= 4 and methodLevel == 3 ) then
			SortGroup_Variable_debugMethodNamePrint = true;
			if ( SortGroup_Variable_debugMethodContentCache ~= methodName ) then
				print(ColorText("SortGroup: Debuging - Method content", "option"));	
			end
			SortGroup_Variable_debugMethodContentCache = methodName;
			print( "'" .. methodName .. "()' " .. tostring(methodContent));
		end		
	end
end
-- Debug, goes through everything

local function ProfileExists(raidProfile)
	Debug("ProfileExists", "", 2);
	local raidprofilexists = false;
	for i=1, GetNumRaidProfiles(), 1 do
		ddmItems[i] = GetRaidProfileName(i);
		if ( ddmItems[i] == raidProfile ) then
			raidprofilexists = true;
		end
	end
	Debug("ProfileExists", tostring(raidprofilexists), 3);
	return raidprofilexists;
end
--Fills ddmItems with raidprofiles and checks if raidprofil exists

local function ExecuteSwitchRaidProfiles(profile)
	Debug("ExecuteSwitchRaidProfiles", "", 2);
	Debug("ExecuteSwitchRaidProfiles", "to profile: " .. profile, 3);
	
	--[[
	CompactUnitFrameProfiles.selectedProfile = profile;
	SaveRaidProfileCopy(profile);
	SetCVar("activeCUFProfile", profile);
	UIDropDownMenu_SetSelectedValue(CompactUnitFrameProfilesProfileSelector, profile);
	UIDropDownMenu_SetText(CompactUnitFrameProfilesProfileSelector, profile);	
	UIDropDownMenu_SetSelectedValue(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);
	UIDropDownMenu_SetText(CompactRaidFrameManagerDisplayFrameProfileSelector, profile);		
	CompactUnitFrameProfiles_ApplyCurrentSettings();
	--CompactUnitFrameProfiles_UpdateCurrentPanel();
	--Taint - Disabled
	CompactUnitFrameProfiles_HidePopups();
	--]]
	CompactUnitFrameProfiles_ActivateRaidProfile(profile);
end

local function SwitchRaidProfiles()
	Debug("SwitchRaidProfiles", "", 2);
	if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
		member = tonumber(GetNumGroupMembers());
		if ( HasLoadedCUFProfiles() == true ) then
			if ( intern_inCombat == false and defaultValues_DB.Profile ~= nil ) then
				if ( member <= 5 and ProfileExists(defaultValues_DB.Profile) ) then
					if ( GetActiveRaidProfile() ~= defaultValues_DB.Profile ) then
						ExecuteSwitchRaidProfiles(defaultValues_DB.Profile);
						if ( defaultValues_DB.ChatMessagesOn == true ) then
							print( ColorText(L["RaidProfil_changed"]:gsub("'replacement'", defaultValues_DB.Profile), "option") );
						end
					end
				end
			end
		end
	end
end
-- Possible switch by Group_Roster, OK button, COMPACT_UNIT_FRAME_PROFILES_LOADED, PLAYER_REGEN_ENABLED, cbAutoActivate_Main or ddmProfiles

local function SortTopDescending()
	Debug("SortTopDescending", "", 2);
	LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_TopDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_TopDownwards)
end

local function SortTopAscending()
	Debug("SortTopAscending", "", 2);
	LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_TopUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return true;
		elseif UnitIsUnit(t2, "player") then 
			return false;
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_TopUpwards)
end
	
local function SortBottomDescending()
	Debug("SortBottomDescending", "", 2);
	LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_BottomUpwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 > t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_BottomUpwards)
end

local function SortBottomAscending()
	Debug("SortBottomAscending", "", 2);
	LoadAddOn("CompactRaidFrameContainer");
	local CRFSort_BottomDownwards = function(t1, t2)
		if UnitIsUnit(t1, "player") then 
			return false;
		elseif UnitIsUnit(t2, "player") then 
			return true; 
		else 
			return t1 < t2;
		end 
	end
	CompactRaidFrameContainer_SetFlowSortFunction(CompactRaidFrameContainer, CRFSort_BottomDownwards)
end

local function CheckProfileOptions()
	Debug("CheckProfileOptions", "", 2);
	if ( GetNumGroupMembers() <= 5 ) then
		if ( CompactUnitFrameProfilesRaidStylePartyFrames:GetChecked() == false ) then
			CompactUnitFrameProfilesRaidStylePartyFrames:Click("LeftButton",true);
			Debug("CheckProfileOptions", "RaidStylePartyFrames clicked", 3);
		end
		if ( CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:GetChecked() == true ) then
			--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether:Click();
			--taints if activated - need to make a work around
			if ( defaultValues_DB.ChatMessagesOn == true ) then	
				print(ColorText(L["Keep_Group_Together_Active"], "option"));
			end
			Debug("CheckProfileOptions", "KeepGroupsTogether checked", 3);
		end
	end
end
--necessary changes, otherwise there is no sort
--CompactUnitFrameProfilesGeneralOptionsFrameKeepGroupsTogether taints, so User needs to do this

local function ChoseSort(SortOption, RaidProfileName, ExternSwitch)	
	Debug("ChoseSort", "", 2);
	if ( ExternSwitch == true ) then 
		SwitchRaidProfiles();
	elseif ( intern_inCombat == false ) then
		if ( RaidProfileName ~= nil and GetNumGroupMembers() <= 5 and HasLoadedCUFProfiles() == true ) then
			if ( GetActiveRaidProfile() ~= RaidProfileName and AutoActivate == false and defaultValues_DB.AlwaysActive == false ) then
				if ( intern_showChatMessages == true ) then
					if ( defaultValues_DB.ChatMessagesOn == true ) then
						print(ColorText(L["RaidProfil_Doesnt_match"], "option"));
					end
				end
			elseif ( GetActiveRaidProfile() == RaidProfileName or defaultValues_DB.AlwaysActive == true ) then
				if ( SortOption == 'Down') then
					if ( defaultValues_DB.TopDescending == true ) then
						if ( intern_showChatMessages == true ) then
							if ( defaultValues_DB.AlwaysActive == true ) then
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_top_downwards_regardless"], "option"));
								end
							else
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_top_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckProfileOptions();
						SortTopDescending();
					end
					if ( defaultValues_DB.TopAscending == true ) then
						if ( intern_showChatMessages == true ) then
							if ( defaultValues_DB.AlwaysActive == true ) then
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_top_upwards_regardless"], "option"));
								end
							else
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_top_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckProfileOptions();
						SortTopAscending();
					end
				elseif ( SortOption == 'Up') then
					if ( defaultValues_DB.BottomDescending == true ) then
						if ( intern_showChatMessages == true ) then
							if ( defaultValues_DB.AlwaysActive == true ) then
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_bottom_downwards_regardless"], "option"));
								end
							else
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_bottom_downwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckProfileOptions();
						SortBottomAscending();
					end
					if ( defaultValues_DB.BottomAscending == true ) then
						if ( intern_showChatMessages == true ) then
							if ( defaultValues_DB.AlwaysActive == true ) then
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_bottom_upwards_regardless"], "option"));
								end
							else
								if ( defaultValues_DB.ChatMessagesOn == true ) then
									print(ColorText(L["sort_bottom_upwards"]:gsub("'replacement'", RaidProfileName), "option"));
								end
							end
						end
						CheckProfileOptions();
						SortBottomDescending();
					end
				end
			end	
		end
	end
end
-- Final decision, which Raid defaultValues_DB.Profile gets loaded and which Sort Method will be used

local function SortInterstation(ExternSwitch)
	Debug("SortInterstation", "", 2);
	if ( defaultValues_DB.AlwaysActive == false ) then
		if ( defaultValues_DB.Top == true or defaultValues_DB.Bottom == true ) then
			if ( ProfileExists(defaultValues_DB.Profile) == false ) then
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					local cachePrintSendSortOptionToSortBy = L["RaidProfil_dont_exists"]:gsub("'replacement'", defaultValues_DB.Profile);
					defaultValues_DB.Profile = GetRaidProfileName(1);
					print(ColorText(cachePrintSendSortOptionToSortBy:gsub("'replacement2'", defaultValues_DB.Profile), "option"));
				end
				UIDropDownMenu_SetText(ddmProfiles, defaultValues_DB.Profile);
			end
		end
	end
	if ( ExternSwitch == true ) then
		ChoseSort("","", true);
	end
	if ( defaultValues_DB.Top == true ) then
		ChoseSort('Down', defaultValues_DB.Profile, false);
	elseif ( defaultValues_DB.Bottom == true ) then
		ChoseSort('Up', defaultValues_DB.Profile, false);
	else
		if ( intern_showChatMessages == true ) then
			if ( defaultValues_DB.ChatMessagesOn == true and SortGroup_Variable_Page3_chatMessagesCurrentOptions == true ) then
				print (ColorText(L["sort_no"], "option"));
			end	
		end
	end
	intern_showChatMessages = false;
end
-- Breakpoint between Methods and ChoseSort

local function UpdateComboBoxes()
	Debug("UpdateComboBoxes", "", 2);
	
	if ( defaultValues_DB.AutoActivate == true ) then
		cbAutoActivate_Main:SetChecked(true);
		getglobal(cbAutoActivate_Main:GetName() .. 'Text'):SetText(ColorText(L["cbAutoActivate_Option_Text"],"white"));
	else
		cbAutoActivate_Main:SetChecked(false);
	end
	
	if ( defaultValues_DB.AlwaysActive == true ) then
		UIDropDownMenu_DisableDropDown(ddmProfiles);
		cbAutoActivate_Main:Disable();
		getglobal(cbAutoActivate_Main:GetName() .. 'Text'):SetText(ColorText(L["cbAutoActivate_Option_Text"],"disable"));
		cbAlwaysActive_Main:SetChecked(true);
	else
		defaultValues_DB.AlwaysActive = false;
		cbAutoActivate_Main:Enable();
		getglobal(cbAutoActivate_Main:GetName() .. 'Text'):SetText(ColorText(L["cbAutoActivate_Option_Text"], "white"));
		if ( cbAutoActivate_Main:GetChecked() == true ) then
			UIDropDownMenu_EnableDropDown(ddmProfiles);
		end
		cbAlwaysActive_Main:SetChecked(false);
	end
	
	if ( defaultValues_DB.Top == true ) then
		cBTop_Main:SetChecked(true);
		cBBottom_Main:SetChecked(false);
		cbTopDescending_Main:Enable();
		cbTopAscending_Main:Enable();
		cbBottomDescending_Main:Disable();
		cbBottomAscending_Main:Disable();
		getglobal(cbTopDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbTopAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"], "white"));
		getglobal(cbBottomDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"],"disable"));
	elseif ( defaultValues_DB.Bottom == true ) then
		cBTop_Main:SetChecked(false);
		cBBottom_Main:SetChecked(true);
		cbTopDescending_Main:Disable();
		cbTopAscending_Main:Disable();
		cbBottomDescending_Main:Enable();
		cbBottomAscending_Main:Enable();
		getglobal(cbTopDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"], "white"));
		getglobal(cbBottomAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"], "white"));
	else
		cBTop_Main:SetChecked(false);
		cBBottom_Main:SetChecked(false);
		cbTopDescending_Main:Disable();
		cbTopAscending_Main:Disable();
		cbBottomDescending_Main:Disable();
		cbBottomAscending_Main:Disable();
		getglobal(cbTopDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbTopAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"],"disable"));
		getglobal(cbBottomDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"],"disable"));
		getglobal(cbBottomAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"],"disable"));
	end
	
	if ( defaultValues_DB.TopDescending == true ) then
		cbTopDescending_Main:SetChecked(true);
		cbTopAscending_Main:SetChecked(false);
	elseif ( defaultValues_DB.TopAscending == true ) then
			cbTopDescending_Main:SetChecked(false);
			cbTopAscending_Main:SetChecked(true);
	else 	
		cbTopDescending_Main:SetChecked(false);
		cbTopAscending_Main:SetChecked(false);
	end
	if ( defaultValues_DB.BottomDescending == true ) then
		cbBottomDescending_Main:SetChecked(true);
		cbBottomAscending_Main:SetChecked(false);
	elseif ( defaultValues_DB.BottomAscending == true ) then
		cbBottomDescending_Main:SetChecked(false);
		cbBottomAscending_Main:SetChecked(true);
	else
		cbBottomDescending_Main:SetChecked(false);
		cbBottomAscending_Main:SetChecked(false);
	end
	
	if ( defaultValues_DB.ChatMessagesOn == true ) then
		cbChatMessagesOn_Options:SetChecked(true);
	else 
		cbChatMessagesOn_Options:SetChecked(false);
	end
	if ( defaultValues_DB.RaidProfilesUpdateInCombat == true ) then
		cbRaidProfilesUpdateInCombat_Options:SetChecked(true);
	else
		cbRaidProfilesUpdateInCombat_Options:SetChecked(false);
	end
end
-- Updating all displayed elements
	
local function resetRaidContainer()	
	if ( defaultValues_DB.RaidProfilesUpdateInCombat == false ) then
		Debug("resetRaidContainer", "", 2);
		local old_CompactRaidFrameContainer_TryUpdate = CompactRaidFrameContainer_TryUpdate
		CompactRaidFrameContainer_TryUpdate = function(self)	
			if ( intern_inCombat == true ) then
				UpdateTable[self:GetName()] = "CompactRaidFrameContainer_TryUpdate"
			else
				old_CompactRaidFrameContainer_TryUpdate(self)
			end
		end
		
		local old_CompactRaidGroup_UpdateUnits = CompactRaidGroup_UpdateUnits
		CompactRaidGroup_UpdateUnits = function(self)
			if ( intern_inCombat == true ) then
				UpdateTable[self:GetName()] = "CompactRaidGroup_UpdateUnits"
			else
				old_CompactRaidGroup_UpdateUnits(self)
			end
		end
		
		if ( internValues_DB.RaidProfilesUpdateInCombatVisibility == true ) then
			local old_CompactUnitFrame_UpdateInRange = CompactUnitFrame_UpdateInRange
			hooksecurefunc("CompactUnitFrame_UpdateInRange", function(self)
				if not UnitExists(self.displayedUnit) then
					self:SetAlpha(0.1);
				else
					old_CompactUnitFrame_UpdateInRange(self);
				end
			end)
		end	
	end
end

local function ProfileChangedEvent()
	if ( internValues_DB.CatchProfileSwitchEvent == true ) then
		local old_CompactUnitFrameProfiles_ActivateRaidProfile = CompactUnitFrameProfiles_ActivateRaidProfile;
		hooksecurefunc("CompactUnitFrameProfiles_ActivateRaidProfile", function(profile)
			Debug("ProfileChanged", "", 2);
			if ( (intern_inCombat == false or internValues_DB.ChangesInCombat == true) and defaultValues_DB.AlwaysActive == true) then
				SortInterstation(false);
				Debug("ProfileChanged", "true", 3);
			else
				old_CompactUnitFrameProfiles_ActivateRaidProfile(profile);
			end
		end)
	end
end
-- Event to catch Raid Profile changes

local function SaveOptions()
	Debug("SaveOptions", "", 2);
	SortGroup_SavedVariables_DB = defaultValues_DB;
end

function SortGroup_Method_GetAutoActivate()
	print(defaultValues_DB.AutoActivate);
	return defaultValues_DB.AutoActivate;
end

function SortGroup_Method_GetProfile()
	return defaultValues_DB.Profile;
end
--Global functions to get informations to ProfileSwitcher - if active


local function createFrame()	
	Debug("createFrame", "", 2);
	frame_Main.name = "SortGroup";
	fontFrame_Main:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFrame_Main:SetTextColor(1, 0.8, 0);
    fontFrame_Main:SetPoint("TOPLEFT", 12, -18);
    fontFrame_Main:SetText("SortGroup");
	
	if ( EscIntepretAsOK == true ) then
		InterfaceOptionsFrameCancel:SetScript("OnClick", function()
			Debug("InterfaceOptionsFrameIntepretetAsOk", "", 2);
			InterfaceOptionsFrameOkay:Click();
		end)
	else
		frame_Main.cancel = function(frame_Main)
			Debug("InterfaceOptionsFrameCancel", "", 2);
			SortInterstation(false);
		end
	end
	
	frame_Main.okay = function(frame_Main)
		Debug("InterfaceOptionsFrameOkay", "", 2);
		SortInterstation(true);
	end
	InterfaceOptions_AddCategory(frame_Main);
	
	frame_Options.name = L["fontFramePage3_Options_Name"];
	fontFrame_Options:SetFont("Fonts\\FRIZQT__.TTF", 18);
	fontFrame_Options:SetTextColor(1, 0.8, 0);
    fontFrame_Options:SetPoint("TOPLEFT", 12, -18);
    fontFrame_Options:SetText(L["fontFramePage3_Options_Name"].."|r");
	frame_Options.parent = frame_Main.name;
	InterfaceOptions_AddCategory(frame_Options);
end

local function createText()
	Debug("createText", "", 2);
	
	textVersion:SetPoint("TOPLEFT", 20, -45);
	textVersion:SetFontObject(GameFontHighlightSmall);
	textVersion:SetText(version);
	textVersion:SetSize(string.len(version), 10);
	
	textAuthor:SetPoint("TOPLEFT", 20 ,-55);
	textAuthor:SetFontObject(GameFontHighlightSmall);
	textAuthor:SetText(author);
	textAuthor:SetSize(string.len(author), 10);
end

local function createCheckbox()	
	Debug("createCheckbox", "", 2);
	cBTop_Main:SetPoint("TOPLEFT", fontFrame_Main, 10, -100);
	cBBottom_Main:SetPoint("TOPLEFT", fontFrame_Main, 10, -200);
	cbTopDescending_Main:SetPoint("TOPLEFT", 30, -30);
	cbTopAscending_Main:SetPoint("TOPLEFT", 30, -55);
	cbBottomDescending_Main:SetPoint("TOPLEFT", 30, -30);
	cbBottomAscending_Main:SetPoint("TOPLEFT", 30, -55);
	cbAlwaysActive_Main:SetPoint("TOPLEFT", fontFrame_Main, 340, -100);
	cbAutoActivate_Main:SetPoint("TOPLEFT",30,-30);	
	getglobal(cBTop_Main:GetName() .. 'Text'):SetText(ColorText(L["cBTop_Option_Text"], "white"));
	getglobal(cBBottom_Main:GetName() .. 'Text'):SetText(ColorText(L["cBBottom_Option_Text"], "white"));
	getglobal(cbTopDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbTopAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbBottomDescending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbDownwards_Option_Text"], "white"));
	getglobal(cbBottomAscending_Main:GetName() .. 'Text'):SetText(ColorText(L["cbUpwards_Option_Text"], "white"));
	getglobal(cbAutoActivate_Main:GetName() .. 'Text'):SetText(ColorText(L["cbAutoActivate_Option_Text"], "white"));
	getglobal(cbAlwaysActive_Main:GetName() .. 'Text'):SetText(ColorText(L["cbRegardlessRaidProfile_Option_Text"], "white"));
	--Main frame
	
	cbChatMessagesOn_Options:SetPoint("TOPLEFT", 30, -60);
	cbRaidProfilesUpdateInCombat_Options:SetPoint("TOPLEFT", 30, -90);
	getglobal(cbChatMessagesOn_Options:GetName() .. 'Text'):SetText(ColorText(L["Page3_cbChatMessagesOn_Option_Text"], "white"));	
	getglobal(cbRaidProfilesUpdateInCombat_Options:GetName() .. 'Text'):SetText(ColorText(L["Page3_RaidProfilesUpdateInCombat_Option_Text"], "white"));
	--Option frame
end

local function createButton()
	Debug("createButton", "", 2);
	
	btnReload_Options:SetSize(120, 24);
	btnReload_Options:SetText(L["Page3_OptionsbtnReload_text"]);
	btnReload_Options:SetPoint("TOPLEFT", fontFrame_Options, 40, -450)
end

local function createDropDownMenu()
	Debug("createDropDownMenu", "", 2);
	ddmProfiles.text = _G["DropDownMenuProfiles"];
	ddmProfiles.text:SetText("Empty ddm");
	ddmProfiles:SetPoint("TOPLEFT", -10, -30);		
	ddmProfiles.info = {};
	ddmProfiles.initialize = function(self, level)
		if ( intern_inCombat == false and level == 1 ) then
			wipe(self.info);
			ProfileExists();
			for i, value in pairs(ddmItems) do
				self.info.text = value;
				self.info.value = i;
				self.info.func = function(item)
					if ( ProfileExists(value) == true ) then
						self.selectedID = item:GetID();
						self.text:SetText(item);
						self.value = i;
						defaultValues_DB.Profile = value;
						UIDropDownMenu_SetText(ddmProfiles, defaultValues_DB.Profile);
						intern_showChatMessages = true;
						SortInterstation(true);
					else
						Debug("createDropDownMenu", "error - RaidProfile doesn't exists", 3);
					end
				end
				self.info.checked = i == self.text:GetText();
				UIDropDownMenu_AddButton(self.info, level);
				if ( defaultValues_DB.Profile == self.info.text ) then
					UIDropDownMenu_SetSelectedID(ddmProfiles, i);
				end
			end
		else
			if ( defaultValues_DB.ChatMessagesOn == true and SortGroup_Variable_Page3_ChatMessagesWarnings == true ) then
				print(ColorText(L["in_combat_options"], "option"));
			end
		end
	end
	ddmProfiles:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["ddmProfiles_Title"] .. "\n\n" .. ColorText(L["ddmProfiles_ToolTip_Text"], "white"), nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	ddmProfiles:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
end
--DropDownMenu creating, include items
--- End Creating



local function frameEvent()
	Debug("frameEvent", "", 2);
	frame_Main:RegisterEvent("COMPACT_UNIT_FRAME_PROFILES_LOADED");
	frame_Main:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame_Main:RegisterEvent("PLAYER_LOGOUT");
	frame_Main:RegisterEvent("PLAYER_REGEN_DISABLED");
	frame_Main:RegisterEvent("PLAYER_REGEN_ENABLED");
	frame_Main:RegisterEvent("GROUP_ROSTER_UPDATE");
	frame_Main:SetScript("OnEvent", 
		function(self, event, ...)	
			if ( event == "PLAYER_LOGOUT" ) then 
				Debug("PLAYER_LOGOUT", "", 2);
				SaveOptions();
				frame_Main:UnregisterEvent(event);
			elseif ( event == "PLAYER_REGEN_DISABLED" ) then
				Debug("PLAYER_REGEN_DISABLED", "", 2);
				intern_inCombat = true;
			elseif ( event == "PLAYER_REGEN_ENABLED" ) then
				Debug("PLAYER_REGEN_ENABLED", "", 2);
				intern_inCombat = false;
				for k, v in pairs(UpdateTable) do
					UpdateTable[k] = nil
					_G[v](_G[k])
				end
				if ( defaultValues_DB.AutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SortInterstation(true);
				else
					SortInterstation(false);
				end
			elseif ( event == "GROUP_ROSTER_UPDATE" ) then
				Debug("GROUP_ROSTER_UPDATE", "", 2);
				if ( defaultValues_DB.AutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
					SortInterstation(true);
				else
					SortInterstation(false);
				end
			elseif ( event == "COMPACT_UNIT_FRAME_PROFILES_LOADED" ) then
				Debug("COMPACT_UNIT_FRAME_PROFILES_LOADED", "", 2)
				defaultValues_DB.Profile = GetRaidProfileName(1);
				-- first time it's possibly to get the profile name - to set the default value
				
				if ( SortGroup_SavedVariables_DB == nil ) then
					SortGroup_SavedVariables_DB = nil;
					SortGroup_SavedVariables_DB = defaultValues_DB;
				elseif ( SortGroup_SavedVariables_DB.FreshDB ~= true ) then
					SortGroup_SavedVariables_DB = nil;
					SortGroup_SavedVariables_DB = defaultValues_DB;
					print(ColorText(L["Sortgroup_reset_output"], "option"));
				end
				
				defaultValues_DB.Top = SortGroup_SavedVariables_DB.Top;
				defaultValues_DB.TopDescending = SortGroup_SavedVariables_DB.TopDescending;
				defaultValues_DB.TopAscending = SortGroup_SavedVariables_DB.TopAscending;
				defaultValues_DB.Bottom = SortGroup_SavedVariables_DB.Bottom;
				defaultValues_DB.BottomDescending = SortGroup_SavedVariables_DB.BottomDescending;
				defaultValues_DB.BottomAscending = SortGroup_SavedVariables_DB.BottomAscending;
				defaultValues_DB.AutoActivate = SortGroup_SavedVariables_DB.AutoActivate;
				defaultValues_DB.AlwaysActive = SortGroup_SavedVariables_DB.AlwaysActive;
				defaultValues_DB.Profile = SortGroup_SavedVariables_DB.Profile;
				defaultValues_DB.ChatMessagesOn = SortGroup_SavedVariables_DB.ChatMessagesOn;
				defaultValues_DB.RaidProfilesUpdateInCombat = SortGroup_SavedVariables_DB.RaidProfilesUpdateInCombat;
				defaultValues_DB.FreshDB = SortGroup_SavedVariables_DB.FreshDB;
				
				UIDropDownMenu_SetText(ddmProfiles, defaultValues_DB.Profile);
				UpdateComboBoxes();
				--Get informations
				
				resetRaidContainer();
				ProfileChangedEvent();
				-- Both are only activatable by internValues_DB
				
				intern_showChatMessages = true;
				SortInterstation(true);
				frame_Main:UnregisterEvent(event);	
			elseif ( event == "PLAYER_ENTERING_WORLD" and HasLoadedCUFProfiles() == true and intern_inCombat == false ) then	
				Debug("PLAYER_ENTERING_WORLD", "", 2);		
				SortInterstation(false);
				-- Start sort
			end
		end);
end

local function checkBoxEvent()
	Debug("checkBoxEvent", "", 2);
	cBTop_Main:SetScript("OnClick",
		function()
			Debug("cBTop_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cBTop_Main:GetChecked() == true ) then
					defaultValues_DB.Top = true;
					defaultValues_DB.Bottom = false;
					if ( cbTopDescending_Main:GetChecked() == false and cbTopAscending_Main:GetChecked() == false ) then
						defaultValues_DB.TopDescending = true;
					end
				elseif ( cBTop_Main:GetChecked() == false ) then	
					defaultValues_DB.Top = false;
				end
				SaveOptions();
				UpdateComboBoxes();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cBTop_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBTop_Option_Text"] .."\n\n" .. ColorText(L["cBTop_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBTop_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Top
		
	cBBottom_Main:SetScript("OnClick",
		function()
			Debug("cBBottom_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cBBottom_Main:GetChecked() == true ) then
					defaultValues_DB.Top = false;
					defaultValues_DB.Bottom = true;
					if ( cbBottomDescending_Main:GetChecked() == false and cbBottomAscending_Main:GetChecked() == false ) then
						defaultValues_DB.BottomAscending = true;
						cbBottomAscending_Main:SetChecked(true);
					end
				elseif ( cBBottom_Main:GetChecked() == false ) then	
					defaultValues_DB.Bottom = false;
				end
				SaveOptions();
				UpdateComboBoxes();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);
	cBBottom_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cBBottom_Option_Text"] .."\n\n" .. ColorText(L["cBBottom_ToolTip_text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cBBottom_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox Bottom
	
	cbTopDescending_Main:SetScript("OnClick",
		function()
			Debug("cbTopDescending_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbTopDescending_Main:GetChecked() == true ) then
					defaultValues_DB.TopDescending = true;
					defaultValues_DB.TopAscending = false;
				elseif ( cbTopDescending_Main:GetChecked() == false ) then	
					defaultValues_DB.TopDescending = false;
				end
				SaveOptions();
				UpdateComboBoxes();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopDescending_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. ColorText(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopDescending_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDescending_Main
	
	cbTopAscending_Main:SetScript("OnClick",
		function()
			Debug("cbTopAscending_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbTopAscending_Main:GetChecked() == true ) then
					defaultValues_DB.TopDescending = false;
					defaultValues_DB.TopAscending = true;
				elseif ( cbTopAscending_Main:GetChecked() == false ) then	
					defaultValues_DB.TopAscending = false;
				end
				SaveOptions();
				UpdateComboBoxes();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbTopAscending_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. ColorText(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbTopAscending_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDescending_Main
	
	cbBottomDescending_Main:SetScript("OnClick",
		function()
			Debug("cbBottomDescending_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbBottomDescending_Main:GetChecked() == true ) then
					defaultValues_DB.BottomDescending = true;
					defaultValues_DB.BottomAscending = false;
				elseif ( cbBottomDescending_Main:GetChecked() == false ) then	
					defaultValues_DB.BottomDescending = false;
				end
				SaveOptions();
				SortInterstation(false);
				UpdateComboBoxes();
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomDescending_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbDownwards_Option_Text"] .."\n\n" .. ColorText(L["cbDownwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomDescending_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDescending_Main
	
	cbBottomAscending_Main:SetScript("OnClick",
		function()
			Debug("cbBottomAscending_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbBottomAscending_Main:GetChecked() == true ) then
					defaultValues_DB.BottomDescending = false;
					defaultValues_DB.BottomAscending = true;
				elseif ( cbBottomAscending_Main:GetChecked() == false ) then	
					defaultValues_DB.BottomAscending = false;
				end
				SaveOptions();
				SortInterstation(false);
				UpdateComboBoxes();
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbBottomAscending_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbUpwards_Option_Text"] .."\n\n" .. ColorText(L["cbUpwards_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbBottomAscending_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)	
	--Combobox cbTopDescending_Main
		
	cbAutoActivate_Main:SetScript("OnClick",
		function()
			Debug("cbAutoActivate_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbAutoActivate_Main:GetChecked() == true ) then
					defaultValues_DB.AutoActivate = true;
					if ( defaultValues_DB.AutoActivate == true or SortGroup_Variable_Page2_AdditionalSwitchActive == true ) then
						SortInterstation(true);
					else
						SortInterstation(false);
					end
				elseif ( cbAutoActivate_Main:GetChecked() == false ) then
					defaultValues_DB.AutoActivate = false;
				end
				SaveOptions();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
				UpdateComboBoxes();
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbAutoActivate_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbAutoActivate_Option_Text"] .."\n\n" .. ColorText(L["cbAutoActivate_ToolTip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAutoActivate_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox AutoActive
		
	cbAlwaysActive_Main:SetScript("OnClick",
		function()
			Debug("cbAlwaysActive_Main", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				intern_showChatMessages = true;
				if ( cbAlwaysActive_Main:GetChecked() == true ) then
					defaultValues_DB.AlwaysActive = true;
					UIDropDownMenu_DisableDropDown(ddmProfiles);
					SortInterstation(false);
				elseif ( cbAlwaysActive_Main:GetChecked() == false ) then
					defaultValues_DB.AlwaysActive = false;
					cbAutoActivate_Main:Enable();
					UIDropDownMenu_EnableDropDown(ddmProfiles);
					getglobal(cbAutoActivate_Main:GetName() .. 'Text'):SetText(L["cbAutoActivate_Option_Text"]);
				end
				SaveOptions();
				UpdateComboBoxes();
				SortInterstation(false);
				Debug("checkBoxEvent", "", 1);
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);		
	cbAlwaysActive_Main:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["cbRegardlessRaidProfile_Option_Text"] .."\n\n" .. ColorText(L["cbAlwaysActive_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbAlwaysActive_Main:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox defaultValues_DB.AlwaysActive
			
	
	cbChatMessagesOn_Options:SetScript("OnClick",
		function()
			Debug("cbChatMessagesOn_Options", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				if ( cbChatMessagesOn_Options:GetChecked() == true ) then
					defaultValues_DB.ChatMessagesOn = true;
					print(ColorText(L["chat_Messages_On"], "option"));
				elseif ( cbChatMessagesOn_Options:GetChecked() == false ) then
					defaultValues_DB.ChatMessagesOn = false;
				end
				SaveOptions();
				Debug("checkBoxEvent", "", 1);
				UpdateComboBoxes();
			else
				UpdateComboBoxes(true);
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);
	cbChatMessagesOn_Options:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_cbChatMessagesOn_Option_Text"] .."\n\n" .. ColorText(L["Page3_cbChatMessagesOn_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbChatMessagesOn_Options:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox defaultValues_DB.ChatMessagesOn
	
	cbRaidProfilesUpdateInCombat_Options:SetScript("OnClick",
		function()
			Debug("cbRaidProfilesUpdateInCombat_Options", "", 2);
			if ( intern_inCombat == false or internValues_DB.ChangesInCombat == true ) then
				if ( cbRaidProfilesUpdateInCombat_Options:GetChecked() == true ) then
					defaultValues_DB.RaidProfilesUpdateInCombat = true;
				elseif ( cbRaidProfilesUpdateInCombat_Options:GetChecked() == false ) then
					defaultValues_DB.RaidProfilesUpdateInCombat = false;
				end
				SaveOptions();
				Debug("cbRaidProfilesUpdateInCombat_Options", "", 1);
				UpdateComboBoxes();
			else
				UpdateComboBoxes();
				if ( defaultValues_DB.ChatMessagesOn == true ) then
					print(ColorText(L["in_combat_options"], "option"));
				end
			end
		end);
	cbRaidProfilesUpdateInCombat_Options:SetScript("OnEnter", 
		function(self)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			GameTooltip:AddLine(L["Page3_RaidProfilesUpdateInCombat_Option_Text"] .."\n\n" .. ColorText(L["Page3_RaidProfilesUpdateInCombat_Tooltip_Text"], "white") , nil, nil, nil, 1);
			GameTooltip:Show();
		end);
	cbRaidProfilesUpdateInCombat_Options:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
	--Combobox defaultValues_DB.RaidProfilesUpdateInCombat
end
--ComboBox Events

local function buttonEvent()
	Debug("buttonEvent", "", 2);
	
	btnReload_Options:SetScript("OnClick",
		function()
			ReloadUI();
		end);
end
---End Events



local loader = CreateFrame("Frame")
loader:RegisterEvent("ADDON_LOADED")
loader:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "SortGroup" then
		Debug("StartAddon", "", 2);
		createFrame();
		createText();
		createCheckbox();
		createButton();
		createDropDownMenu();
		frameEvent();	
		checkBoxEvent();
		buttonEvent();
		self:UnregisterEvent("ADDON_LOADED")
	end
end)